(*
$Id: error.ml,v 1.1.1.1 1998/06/23 22:35:07 monniaux Exp $
*)

let skip_space () = output_string stderr "--    global     -- ";;

let failure where what = skip_space ();
  Printf.fprintf stderr "*INTERNAL*ERROR* Failure during %s: %s\n" where what;
  raise Exit;;

let unimplemented where f a b = skip_space ();
  Printf.fprintf stderr "*INTERNAL*ERROR* Unimplemented internal in %s at %s:%d-%d\n" where f a b;
  raise Exit;;

(* Message d'erreur de syntaxe *)
let syntax_error message ((nl1,nc1),(nl2,nc2)) =
  Printf.fprintf stderr "%5d:%3d-%5d:%3d *SYNTAX  *ERROR* %s\n" nl1 nc1 nl2 nc2 message;;

(* Message d'erreur semantique *)
let sem_error message ((nl1,nc1),(nl2,nc2)) =
  Printf.fprintf stderr "%5d:%3d-%5d:%3d *SEMANTIC*ERROR* %s\n" nl1 nc1 nl2 nc2 message;;

(* Message d'erreur du gnrateur de code *)
let codegen_error message = skip_space ();
  Printf.fprintf stderr "*CODEGEN *ERROR* %s\n"
  message; raise Exit;;

let fatal_error message = skip_space ();
  Printf.fprintf stderr "*INTERNAL*ERROR* %s\n"
  message; raise Exit;;


